leetcode 287. Find the Duplicate Number(二分/快慢指针)

1.二分方法
因为数字是1~n,所以我们可以根据小于mid的数目来判断重复的数字是在左边还是右边

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        int left = 1,right = nums.size()-1;
        while(left <= right){
            int mid = (left+right) >> 1;
            int cnt = 0;
            for(int x : nums)
                if(x <= mid)
                    cnt++;
            if(cnt > mid)
                right = mid-1;
            else
                left = mid+1;
        }
        return left;
    }
};

2.快慢指针
类似于142. Linked List Cycle II

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        int fast = 0, slow = 0;
        while(true){
            fast = nums[nums[fast]];
            slow = nums[slow];
            if(fast == slow){
                fast = 0;
                while(fast != slow){
                    fast = nums[fast];
                    slow = nums[slow];
                }
                return slow;
            }
        }
        return 0;
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值